// Copyright (c) 2011-2013 Robin Upton <wikipediaPlus [AŦ] RobinUpton [Ð0ŧ] com>
// Changes Since: 2011-11-15
//	2012-04-30	v0.8:	Check isEnabled() onContentLoad()
//						Add 'notificationHeight'
//	2013-04-06	v0.9:	Use the correct notification bar instead of always using the top tab
//						Notify by popping up a bubble in the background
//	2013-04-09	v0.9.1:	Code tidy & Refactored in com.RobinUpton.WikipediaPlus object
//						Fixed/improved code around pagelist editing
//	2013-04-18	v0.9.2:	Fix match logic to reduce useless HEAD requests
//						Correct handling of spaces in PageNames (Bug #8)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
if(!com) var com={};
if(!com.RobinUpton) com.RobinUpton={};
if(!com.RobinUpton.WikipediaPlus) com.RobinUpton.WikipediaPlus={};
com.RobinUpton.WikipediaPlus.urlBarListener = new function() {
	var self = this;
	self.QueryInterface= function(aIID)
	  {
	   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		   aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		   aIID.equals(Components.interfaces.nsISupports))
		 return self;
	   throw Components.results.NS_NOINTERFACE;
	  }
	self.onLocationChange= function(aBrowser, webProgress, aRequest, aURI) { 
		var history =aBrowser.sessionHistory;
		try 
			{ 
			var last = history.getEntryAtIndex(history.count-1, false).URI;
			var prelast = history.getEntryAtIndex(history.count-2, false).URI;
			var ignore = com.RobinUpton.WikipediaPlus.WPMain.URLequalsExceptRef(last, prelast); //on change
			}
		catch (ex)
			{ // On startup, history is empty 
			var ignore = false;
			}
		// @@@ For more efficiency, we might want to keep this URI..
		if (!ignore) com.RobinUpton.WikipediaPlus.WPMain.processNewURL(); //Suppress internal page transitions
	  }
	self.onStateChange= function(a, b, c, d) {}
	self.onProgressChange= function(aBrowser, webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) 
	  { // Check we have enough to work out the real title, then look up...
	  // Improve responsiveness here for 0.9
	  }
	self.onStatusChange= function(a, b, c, d) {}
	self.onSecurityChange= function(a, b, c) {}
};

com.RobinUpton.WikipediaPlus.WPMain = new function() {
	var self = this;
	self.init= function() {
		self.WPManager = Cc['@robinupton.com/WPmanager;1'].getService().wrappedJSObject;
		var addonBar = document.getElementById("addon-bar");
		if (addonBar) //Add to add-on bar (FF>4?)
			{
			if (!document.getElementById("WP-icon"))  addonBar.insertItem("WP-icon");
			if (!document.getElementById("WP-panel")) addonBar.insertItem("WP-panel");
			addonBar.collapsed = false;
			}
		self.registerObservers();
		self.updateIcon();
		self.updateStatusbar();
	}
	
	self.registerObservers= function() {
		var observerService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
		// Listen for change of enabled status
		observerService.addObserver(self.observe, "com.RobinUpton.WikipediaPlus-display", false);
		// Listen for webpage loads
		gBrowser.addProgressListener(com.RobinUpton.WikipediaPlus.urlBarListener, Ci.nsIWebProgress.NOTIFY_LOCATION);
	}
 
	self.tryAndShow= function(thisurl, index, label, icon, uri, accessKey) { //2011-07-10
		var nsXUL = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
		var WM=self.WPManager;
		if ((WM.prefs.getBoolPref("wikipediaPlus.check-suggestions"))
			&& (!(WM.isHomeSite(uri)))
			&& (!self.remotePageExists(uri))) return;
		if (!WM.isEnabled()) return; // 2013-04-09	Helpful immediately after disabling - Suppresses any more suggestions
		var b= self.getBrowserByURL(thisurl); // This line is new and see below about the bubbles from 2013-04-02
		if (b==null) return;
		nb= gBrowser.getNotificationBox(b);
		if (nb==null) return;
		var notification= nb.currentNotification;
		if (notification == null) 
			{
			var buttons= new Array();
			declineButton = new Object();
			declineButton.label 		= " "+self.localisedString('cancel');
			declineButton.accessKey 	= self.localisedString('cancel.k');
			declineButton.callback		= function() {};
			//declineButton.popup			= "WP-cancel-menu";
			if (WM.showCancel) buttons.push (declineButton);
			var message= self.localisedString('notification.'+WM.notificationFormat)+": ";
			nb.appendNotification(message, "wikipediaPlus-suggestions-notification", "chrome://wikipediaPlus/content/images/wikipediaPlus.png", nb.PRIORITY_INFO_HIGH, buttons);
			notification= nb.currentNotification;
			notification.setAttribute('tooltiptext',	self.localisedString('notification.tip'));
			notification.setAttribute('flex',			0);
			if (WM.notificationHeight>0) notification.setAttribute('style',	"height:"+WM.notificationHeight+"px;");
			notification.setAttribute('onclick',		"if (event.detail >1) com.RobinUpton.WikipediaPlus.WPMain.onShowOptions();");
			if (buttons.length) notification.lastChild.setAttribute('image', "chrome://wikipediaPlus/content/images/cancel16.png");
			}
		if (self.suggestionExists(notification, uri)) return; // If a button for this site already exists, stop here.
		if ((nb!= self.getMRW().gBrowser.getNotificationBox()) && (WM.showBubbles)) //2013-04-02
			{ // Notify with a bubble
			WM.displayNotification(self.localisedString('longWPSuggests')+b.contentTitle, uri);
			}
		var button= document.createElementNS(nsXUL,"button");
		button.setAttribute('value',		uri);
		button.setAttribute('tooltiptext',	uri);
		button.setAttribute('onclick',		"com.RobinUpton.WikipediaPlus.WPMain.switchSite(this);");
		button.setAttribute('accesskey',	accessKey);
		if ((WM.suggestionFormat>1) ||
			((WM.suggestionFormat==1) && (!icon.length))) button.setAttribute('label',	label);
		if ((!WM.suggestionFormat) && (!icon.length)) icon="chrome://wikipediaPlus/content/images/icon0.png";
		if ((WM.suggestionFormat !=2) && 
			(WM.suggestionFormat !=3)) button.setAttribute('image', 	icon);
		if ((WM.suggestionFormat ==3) ||
			(WM.suggestionFormat ==5)) button.setAttribute('flex',	1);
		if (WM.showCancel 	  !=2)	notification.appendChild(button);
		else notification.insertBefore(button, notification.lastChild);
	},
 
	self.getBrowserByURL= function(url) { // 2013-04-02 New function for v0.8.1
		var browsers= document.getElementById("content").browsers;
		var i=-1;
		while (++i < browsers.length)
			{ if (browsers[i].contentDocument.URL==url) return browsers[i]; }
		return null; // Can happen if they've moved on
	},

	self.getTokenMatch= function(value, template, token) {
		var temp= template.replace(token,"");
		var tokenmatch=value.replace(temp,"");
		if (tokenmatch.length != value.length) return tokenmatch;
	},

	self.getMRW= function() {
		return Cc["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
	},

	self.getLangCodeMatch= function(url, template, langlist) {
		var langs=langlist.split(" ");
		for (var i=0; i<langs.length; i++)
			{
			var matchedtemplate=template.replace("{LangCode}", langs[i]).replace("%7BLangCode%7D", langs[i]);
			if (self.WPManager.isMatch2(matchedtemplate, url)) return langs[i];
			}
		self.notifyUnexpectedLanguage();
		return ("XX");
	}

	self.handleTemplates= function(newTemplate, thisValue, thisLang, thisTemplate) {
		if (thisLang.split(" ").length>1) 
			thisLang= self.getLangCodeMatch(thisValue, thisTemplate, thisLang);
		if (thisLang=="XX") return; //Non-match - New to 0.9.2
		if (self.parsedTitle.length) var PageName=self.parsedTitle;
		else var PageName=self.trim(self.getTokenMatch(thisValue, thisTemplate.replace("%7BLangCode%7D", thisLang).replace("{LangCode}", thisLang), "%7BPageName%7D"));
	//	alert ("HT\nlang="+thisLang+"\n"+"PageName="+PageName+"\nthisTemplate="+thisTemplate+"\nnewTemplate="+newTemplate+"\nRESULT="+newTemplate.replace("%7BPageName%7D", PageName).replace("%7BLangCode%7D", thisLang).replace("{LangCode}", thisLang)); //%7BPageName%7D and {PageName} depend on the position of the "{PageName}" section in the URI
		if (!self.WPManager.blockedPageName(PageName)) return newTemplate.replace("%7BPageName%7D", PageName).replace("{PageName}", PageName).replace("%7BLangCode%7D", thisLang).replace("{LangCode}", thisLang);
	}

	self.checkAlternatives= function(document) {
		if (!(document instanceof HTMLDocument) || (self.WPManager == null) || !(self.WPManager.isEnabled()) || (document.location == "about:blank")) return;
		var siteId= self.WPManager.getThisSiteID(document.location+"");
		if (typeof(siteId)=="undefined") return;
		var	possibleOptions= self.cloneArray(self.WPManager.siteArray);
		if (self.WPManager.showPreferredOnly) possibleOptions.splice(siteId);
		else possibleOptions.splice(siteId, 1);
		self.parseTitle();
		self.showSiteSuggestions(self.WPManager.siteArray[siteId], possibleOptions);
	}
  /* But see http://zh.wikipedia.org/wiki/%E7%93%A3%E7%AB%8B%E6%A8%93%E6%9E%97%E6%9E%9C - doesn't work as hoped
	self.isBadTitle= function(title) { // A work round for oler Mediawiki versions which send an HTTP 200 code on a bad title
		var badchars="[]{}|#%+?";
		for (var i = 0; i < badchars.length; i++) {
			if (title.indexOf(badchars.charAt(i)) != -1) return true;
			}
		return false;
  	}
  */	
	self.cloneArray= function(a)	{ var cA=[]; for (var i=0; i<a.length; i++ ) cA[i]=a[i]; return cA; }
	self.parseTitle= function() {
		self.parsedTitle="";
		switch (self.WPManager.prefs.getIntPref("wikipediaPlus.suggestion-method"))
			{// Method >0: Handle redirects
			case 1:
				var titleh1= Application.activeWindow.activeTab.document.getElementById("firstHeading");
				if (titleh1!= null) self.parsedTitle= self.trim(self.wikipedify(titleh1.textContent));
			default:
			}
	}
  
	self.URLequalsExceptRef= function(URL1, URL2) { // Are they are on the same page?
		var URLtemp1= URL1.prePath + URL1.path;
		var URLtemp2= URL2.prePath + URL2.path;
		return (self.trimFragment(URLtemp1) == self.trimFragment(URLtemp2));
	}

	self.wikipedify= function(pageTitle) {
		var data=pageTitle.substring(0,1).toUpperCase()+pageTitle.substring(1);	
		return data.replace(/ /g,"_"); // Fix 0.9.2
	}

	self.onContentLoad= function(event) { // When a page finishes loading
	//alert ("onContentLoad "+event.DOMTitleChanged+" - "+(self.WPManager.searchAfter));
	// maybe suppress internal page transitions like the above?? - Careful with this
		if (typeof(self.WPManager)=="undefined") return; // Happens when the add-in is loading
		if (self.WPManager.isEnabled() && self.WPManager.searchAfter)
			{
			self.checkAlternatives(event.originalTarget); // 0.8 Fix!
			}
	}
	
	self.trim= function(str) { 
			if (typeof(str)=="undefined") return; 
			return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
	}
	
	self.onUnload= function() { //tidy up
		gBrowser.removeProgressListener(com.RobinUpton.WikipediaPlus.urlBarListener);
	}

	self.hideNotificationBar= function() {
		self.getMRW().gBrowser.getNotificationBox().removeAllNotifications(false);
	}
  
	self.hostFromURI= function(uri) {
		if (!uri.length || uri=="wikipediaPlus-suggestions-notification") return ""; // Catches image and label
		var tempURL= self.url(uri);
		return tempURL.host;
	}
  //@@@ TODO Below for context menu on  cancel bar - not yet implemented
  //onBlockPagename= function() { alert ("Block Pagename"); }
  //onBlockUrl= function() { alert ("Block Url"); }
  
	  self.onShowOptions= function(event) {
		if (event.button != 0) return;
		window.openDialog('chrome://wikipediaPlus/content/options.xul', 'dialog', 'modal,resizable,scrollbars,status,chrome');
	  }

	self.onToggleEnabled= function(event) {
		if (event.button != 0) return;
		self.toggleEnabled();
		self.updateStatusbar();
	  }
  
	self.processNewURL= function() {
		if (self.WPManager.searchWhile) 
			{
			self.checkAlternatives(self.getMRW().gBrowser.contentDocument);
			}
	}
	  
	self.setDisabledStatus= function() {
		if (self.WPManager.isShortStatus()) 
		  self.setWPPanel('shortDisabled', 'longDisabled', "red", 0);
		else
		  self.setWPPanel('longDisabled', 'longDisabled', "red", 0);
		self.setStatusContext('enable');
		document.getElementById("WP-icon").setAttribute('image','chrome://wikipediaPlus/content/images/wp240.png');
		self.hideNotificationBar();
	}

	self.setEnabledStatus= function() {
		if (self.WPManager.isShortStatus()) 
		  self.setWPPanel('shortEnabled', 'longEnabled', "green", 1);
		else
		  self.setWPPanel('longEnabled', 'longEnabled', "green", 1);
		self.setStatusContext('disable');
		document.getElementById("WP-icon").setAttribute('image','chrome://wikipediaPlus/content/images/wp241.png');
		self.checkAlternatives(self.getMRW().gBrowser.contentDocument);
	}
 
	self.setStatusContext= function (name) {
		document.getElementById("WP-status-context1").label = self.localisedString(name);
		document.getElementById("WP-status-context2").label = self.localisedString(name);
		document.getElementById("WP-status-context3").label = self.localisedString(name);
	}
  
	self.setWPPanel= function (text, tooltip, color, enabled) {
      var panel = document.getElementById("WP-panel");
	  panel.setAttribute("style", "color: "+color+";");
	  panel.setAttribute("tooltiptext", self.localisedString(tooltip));
	  if (panel.textContent) panel.textContent = self.localisedString(text);
	  else panel.label = self.localisedString(text);
	  var icon = document.getElementById("WP-icon");
	  icon.src="chrome://wikipediaPlus/content/images/wp24"+enabled+".png";
  }
  
	self.escape= function(string) { if (string==null) return ''; else return string.replace("'","\\'"); }
	self.url= function(path) {
		var ioSvc = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		return ioSvc.newURI(path, null, null);
	}
	self.showSiteSuggestions= function(currentSite, siteArray) {
		var thisurl=Application.activeWindow.activeTab.uri.spec;
		var thislang= self.getLangCodeMatch(thisurl, currentSite.getAttribute("url"), currentSite.getAttribute("lang"));
		for (var i=0; i<siteArray.length; i++)
			{ //Try and show site
			var trySite= siteArray[i];
			if ((self.WPManager.sameLanguage) && (trySite.getAttribute("lang").indexOf(thislang) == -1)) continue;
			var uri = self.handleTemplates(self.normalise(trySite.getAttribute("url")), thisurl, thislang, self.normalise(currentSite.getAttribute("url"))); //Added 'thisurl' parameter to the below for 0.9
			if (typeof(uri)!="undefined") 
				setTimeout("com.RobinUpton.WikipediaPlus.WPMain.tryAndShow('"+self.escape(thisurl)+"','"+i+"','"+self.escape(trySite.getAttribute('name'))+"','"+self.escape(self.normalise(trySite.getAttribute('icon')))+"','"+self.escape(uri)+"','"+self.escape(trySite.getAttribute('key'))+"')", 1);
			}
	}
 
	self.normalise= function(url) { // Switches the host part of a url into lowercase to simplify matching
		if (url == null || !url.length) return ""; //Prevent exception
		var tempURI= Cc["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null);
		return tempURI.spec;
	}

	self.suggestionExists= function(notification, uri) {
		var thisDomain= self.hostFromURI(uri);
		for (temp=notification.firstChild; temp!= null; temp=temp.nextSibling)
			{
			if (self.hostFromURI(temp.getAttribute("value")) == thisDomain) return true;
			}
		return false;
	}
	
	self.switchSite= function(button) {
		var location=button.getAttribute('value');
		var newURL= self.url(location);
		switch (self.WPManager.suggestionLocation)
			{
			case 0:
				Application.activeWindow.activeTab.load(newURL);
				break;
			case 1:
				Application.activeWindow.open(newURL);
				break;
			case 2:
				var newTab= Application.activeWindow.open(newURL);
				newTab.focus();
				break;
			case 3:
				window.open(location, "_new");
			}
	}

	self.localisedString= function(name) {
		var SB= document.getElementById("WP-string-bundle");
		return SB.getString(name);
	}
  
	self.notifyUnexpectedLanguage= function() {
		// self.WPManager.displayNotification("Unxpected Language!","Your WikipediaPlus sitelist is missing this language. Please update it accordingly.");
	  }
  
	self.observe= function(subject, topic, data) { //Catch a message that the enabled status has changed
		switch (topic)
			{
			case "com.RobinUpton.WikipediaPlus-display":
				self.updateIcon();
				self.updateStatusbar();
			}
	}
	self.remotePageExists= function(URI) { 
		var xmlhttp = Cc["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
		xmlhttp.open ('HEAD', URI, false); // Not ascyhronous, so wait
		try 
			{ xmlhttp.send(null); }
		catch (ex)
			{ 
			if (ex.name == "NS_ERROR_FAILURE") { return false; } // Offline?
			else throw(ex); 
			}
		return (xmlhttp.status < 400);
	}
	self.toggleEnabled= function() {
		self.WPManager.setEnabled(!self.WPManager.isEnabled());
		}
	self.trimFragment= function(URLstring)
		{ // 2011-11-15		For compatability with FF3-5 which don't have this for NSURI
			var fragIndex= URLstring.indexOf("#");
			if (fragIndex == -1) return URLstring;
			return URLstring.substring(0, fragIndex);
		}
	self.updateIcon= function() {
			document.getElementById("WP-icon").collapsed= !this.WPManager.showIcon;
		}
	self.updateStatusbar= function() {
			document.getElementById("WP-panel").collapsed= (self.WPManager.statusbarFormat<1);
			(self.WPManager.isEnabled() ? self.setEnabledStatus() : self.setDisabledStatus());
		}
};

window.addEventListener("load", function()  { com.RobinUpton.WikipediaPlus.WPMain.init();  }, false); 
window.addEventListener("unload", function() { com.RobinUpton.WikipediaPlus.WPMain.onUnload(); }, false);
window.document.addEventListener("DOMContentLoaded", function(e) {com.RobinUpton.WikipediaPlus.WPMain.onContentLoad(e);}, true);
