// Copyright (c) 2011-2013 Robin Upton <wikipediaPlus [AŦ] RobinUpton [Ð0ŧ] com>
// Changes since: 2011-07-12:
//		2012-04-30				Add language auto detect to "Use Current" button
//								Change 'contentDocument' -> 'document' in that same routine. Think this is due to FF12 stricter checking?
//		2013-04-09	v0.9.1		Refactored in com.RobinUpton.WikipediaPlus.AES object
//								Minor GUI improvement


// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
if(!com) var com={};
if(!com.RobinUpton) com.RobinUpton={};
if(!com.RobinUpton.WikipediaPlus) com.RobinUpton.WikipediaPlus={};
com.RobinUpton.WikipediaPlus.AES = new function() {
	var self = this;
	self.init= function() {
		var retVal = window.arguments[0];
		if (retVal.site.hasAttribute('name'))
			{
			var site=retVal.site;
			self.setTitle(self.getSB().getString('Editing')+" "+site.getAttribute("name"));
			document.getElementById("site-name").value =	site.getAttribute("name");
			document.getElementById("site-icon").value = 	site.getAttribute("icon");
			self.onSiteIconTest();
			document.getElementById("site-url").value = 	site.getAttribute("url");
			self.setLanguages(site.getAttribute("lang"));
			document.getElementById("site-key").value  =	site.getAttribute("key");
			} 
		  else
			{
			self.setTitle(self.getSB().getString('Adding'));
			self.setLanguages(self.getSB().getString('DefaultLanguage'));
			}
		}
	self.getSB= function() 					{ return document.getElementById("WP-string-bundle"); }
	self.getSingleLanguageMenu= function() 	{ return document.getElementById("site-langs-single"); }
	self.getMultiLanguageText= function()	{ return document.getElementById("site-langs-multi"); }
	self.getIconText= function()  			{ return document.getElementById("site-icon"); }
	self.getURLText= function()  			{ return document.getElementById("site-url"); }
	self.getLanguages= function() 			{
												if (document.getElementById("site-ml").selectedIndex) 
													return self.getMultiLanguageText().value;
												else
													return self.getSingleLanguageMenu().value.substring(0,2);
											}
	self.deselectLanguages= function() {
										self.getSingleLanguageMenu().selectedIndex=-1;
										//self.deselectElements("richlistitem");
									}
	self.deselectElements= function(tagName) {
												var temp=document.getElementsByTagName(tagName);
												for (i=0;i<temp.length;i++) temp[i].selected=false;
											}
	self.setMultiLanguage= function(status) {
												document.getElementById("site-ml").selectedIndex= status;
												document.getElementById("site-langs-multi").disabled= !status;
												self.getSingleLanguageMenu().disabled= status;
											}
	self.setUrl= function(status) 			{
												self.setUrlItems("site-url-simple", 1-status);
												self.setUrlItems("site-url-advanced", status);
											}
	self.setUrlItems= function(ID, status) {
												var temp=childElements(document.getElementById(ID).parentNode);
												for (i=0;i<temp.length;i++)	i.disabled= !status;
												//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
											}
	self.setLanguage= function(languageCode) {
												self.getSingleLanguageMenu().selectedIndex= self.getSingleLanguageMenu().getIndexOfItem(document.getElementById(languageCode+"1"));
											}
	self.setLanguages= function(languageCodeList) {
												if (typeof(languageCodeList)=="null") return;
												document.getElementById("site-langs-multi").value=languageCodeList;
												var temp = languageCodeList.split(' ');
												self.setMultiLanguage(0+(temp.length>1));
												self.deselectLanguages();
												for (i=temp.length;i>0;) self.setLanguage(temp[--i]);
											}
	self.setTitle= 	function(newTitle) 		{ document.getElementById("WP-add-edit-site").setAttribute("title", newTitle);	};
	self.onDialogOK= function() {  
									var icon	= document.getElementById("site-icon").value;
									var name	= document.getElementById("site-name").value;
									var url 	= document.getElementById("site-url").value;
									var lang	= self.getLanguages();
									var key		= document.getElementById("site-key").value.substring(0,1);
									if (!name) 																return self.myError('ErrorNoName');
									if (!url) 																return self.myError('ErrorNoURL');
									if (url.indexOf("{PageName}") == -1) 									return self.myError('ErrorNoPageName');
									if ((lang.split(" ").length > 1) && (url.indexOf("{LangCode}") == -1)) 	return self.myError('ErrorNoLangCode');
									var retVal = window.arguments[0];
									retVal.site.setAttribute("icon", 	 icon);
									retVal.site.setAttribute("lang", 	 lang);
									retVal.site.setAttribute("name",	 name);
									retVal.site.setAttribute("url", 	 url);
									retVal.site.setAttribute("key", 	 key);
									retVal.OK= true;
									return true;
								}
	self.myError= function(message) { alert (self.getSB().getString(message)); return false; }
	self.onMultiLanguageSelect= function(newvalue) { self.setMultiLanguage(0+newvalue); }
	self.onIconInput= function (textbox) {}
	self.onSiteIconTest= function () {
								   document.getElementById("site-icon-preview").src= document.getElementById("site-icon").value;
								}
	self.onSiteUseCurrent= function() { 
									var aTab= Application.activeWindow.activeTab;
									var root= aTab.document.documentElement;
									if (root.hasAttribute("lang")) self.setLanguage(root.getAttribute("lang"));
									var temp= aTab.uri.spec
									if (temp.substring(temp.length-1,temp.length)=="/") temp=temp.substring(0, temp.length-1);
									var temp=temp.split("/");
									var tempURI="";
									if (temp.length==3) tempURI=aTab.uri.spec;
									else for (var i=0; i<temp.length-1; i++) tempURI+=temp[i]+"/";
									self.getURLText().value= tempURI+"{PageName}";	
									// Possibility to add more voodoo here, such as grab favicon by looking for <link rel="..."> etc. 
									// For now, use old 'standard'.
									self.getIconText().value=temp[0]+"/"+temp[1]+"/"+temp[2]+"/favicon.ico";
									self.onSiteIconTest(); //Added 2013-04-09
								}
	self.onUrlSelect= function(newvalue) { self.setUrl(0+newvalue); }
};

// Init addin after window loaded
window.addEventListener("load", com.RobinUpton.WikipediaPlus.AES.init, false);
