// Copyright (c) 2011-2013 Robin Upton <wikipediaPlus [AŦ] RobinUpton [Ð0ŧ] com>
// Changes since: 2011-07-18
//		2012-05-01			Add NotificationHeight code then comment it out. No GUI needed for it at the moment
//		2013-04-09	v0.9.1	Refactored in com.RobinUpton.WikipediaPlus.Options object
//							Fixed/improved the code around page editing.	 (Bug #7)
//							Added onPageListTreeKeyPress() to support for deletion by keypress

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
if(!com) var com={};
if(!com.RobinUpton) com.RobinUpton={};
if(!com.RobinUpton.WikipediaPlus) com.RobinUpton.WikipediaPlus={};
com.RobinUpton.WikipediaPlus.Options = new function() {
	var self = this;
	self.selectedSiteIndex=-1;
	self.selectedPageIndex=-1;
	self.getSB = function() 				{ return document.getElementById("WP-string-bundle"); }
	self.getAboutLabel = function()			{ return document.getElementById("aboutText"); }
	self.getCurrentSite = function()    	{ return self.getSiteListItem(self.getSiteListTreeIndex()); }
	self.getEnabled = function()			{ return document.getElementById("enabled"); }
	self.getMaxConnInput = function()		{ return document.getElementById("maxConnections"); }
	self.getMaxSuggInput = function()		{ return document.getElementById("maxSuggestions"); }
	self.getNotificationFormat = function()	{ return document.getElementById("notificationFormat"); }
	//self.getNotificationHeight = function(){ return document.getElementById("notificationHeight"); }
	self.getOptionsTabbox = function()		{ return document.getElementById("optionsTabbox"); }
	self.getSameLanguage = function()		{ return document.getElementById("sameLanguage"); }
	self.getSearchWhile = function()		{ return document.getElementById("searchWhile"); }
	self.getShowBubbles = function()		{ return document.getElementById("showBubbles"); }
	self.getShowCancelMenu = function()		{ return document.getElementById("showCancel"); }
	self.getShowIcon = function()			{ return document.getElementById("showIcon"); }
	self.getShowPreferredOnly = function()	{ return document.getElementById("showPreferredOnly"); }
	self.getSiteDemoteButton = function()	{ return document.getElementById("siteDemoteButton"); }
	self.getSitePromoteButton = function()	{ return document.getElementById("sitePromoteButton"); }
	self.getSiteEditButton = function()		{ return document.getElementById("siteEditButton"); }
	self.getSiteRemoveButton = function()	{ return document.getElementById("siteRemoveButton"); }
	self.getSuggestionFormat = function()	{ return document.getElementById("suggestionFormat"); }
	self.getSuggestionLocation = function()	{ return document.getElementById("suggestionLocation"); }
	self.getPageRemoveButton = function()	{ return document.getElementById("pageRemoveButton"); }
	self.getPageListItem = function(index) 	{ var temp=childElements(self.pageList.documentElement); return temp[index]; }
	self.getPageListTree = function()		{ return document.getElementById("pageListTree"); }
	self.getPageListTreeIndex = function()	{ return self.getPageListTree().currentIndex; }
	self.getSiteListItem = function(index)	{ var temp=childElements(self.siteList.documentElement); return temp[index]; }
	self.getSiteListTree = function()		{ return document.getElementById("siteListTree"); }
	self.getSiteListTreeIndex = function()	{ return self.getSiteListTree().currentIndex; }
	self.setSiteListTreeIndex = function(i)	{ self.getSiteListTree().selected =i; }
	self.getSiteListTreeLength = function()	{ return self.getSiteListTree().view.rowCount; }
	self.getSitesTreeParent = function()	{ return document.getElementById("sitesTreeParent"); }
	self.getStatusbarFormat = function()	{ return document.getElementById("statusbarFormat"); }
	self.getStatusIcon = function()			{ return document.getElementById("showIcon"); }
	self.onExportPage = function()			{ alert (saveXML(self.WPManager.getPageDOM(self.pageList))); }
	self.onExportSite = function()			{ alert (saveXML(self.siteList)); }
	
	self.init = function() {
		try { self.WPManager= Components.classes['@robinupton.com/WPmanager;1'].getService().wrappedJSObject; }
		catch (ex)
			{
	//		if (ex.message==" Component returned failure code: 0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE) [nsIJSCID.getService]")
			alert ("Karma failure. Couldn't initialise '@robinupton.com/WPmanager;1' NSIComponent.\n\n["+ex.message+"]\n\n Try uninstalling and reinstalling this add-in??");
			}
		self.WPManager.initializeSiteList();
		self.WPManager.initializePageList();
		self.siteList= 								self.WPManager.getSiteList();
		self.pageList=	 							self.WPManager.getPageList();
		self.update(1,1);
		self.getEnabled().checked=					self.WPManager.enabled;
		self.getMaxConnInput().value= 				self.WPManager.maxConnections;
		self.getMaxSuggInput().value= 				self.WPManager.maxSuggestions;
		self.getSameLanguage().checked=				self.WPManager.sameLanguage;
		self.getSearchWhile().checked= 				self.WPManager.searchWhile;
		self.getShowBubbles().checked=			 	self.WPManager.showBubbles;
		self.getShowCancelMenu().selectedIndex= 	self.WPManager.showCancel;
		self.getShowIcon().checked= 				self.WPManager.showIcon;
		self.getShowPreferredOnly().checked= 		self.WPManager.showPreferredOnly;
		self.getStatusbarFormat().selectedIndex= 	self.WPManager.statusbarFormat;
		self.getNotificationFormat().selectedIndex= self.WPManager.notificationFormat;
		// no GUI for notifaction height
		self.getOptionsTabbox().selectedIndex= 		self.WPManager.optionsTopTab;
		self.getSuggestionFormat().selectedIndex= 	self.WPManager.suggestionFormat;
		self.getSuggestionLocation().selectedIndex=	self.WPManager.suggestionLocation;
		self.getAboutLabel().value=					self.getSB().getString('wikipediaPlus')+" "+self.getSB().getString('version')+ self.WPManager.extensionVersion;
	}

	self.onAddSite = function() {
		var retVal = {site: self.siteList.createElementNS("http://RobinUpton.com/WP/", "site"), OK:false};
		window.openDialog("chrome://wikipediaPlus/content/addEditSite.xul", "dialog2", "modal,resizable,scrollbars,status,chrome", retVal).focus();
		var index= self.getSiteListTreeIndex();
		if (index==-1) index=0;
		if (retVal.OK) self.moveSiteListItem(retVal.site, index);
		self.update(0,1);
	}

	self.onEditSite = function() {
		if (self.getSiteEditButton().disabled) return; //:) 0.7.4 fix
		var retVal = {site: self.getCurrentSite()};
		window.openDialog("chrome://wikipediaPlus/content/addEditSite.xul", "dialog2", "modal,resizable,scrollbars,status,chrome", retVal);
		self.WPManager.changeSiteList();
		self.update(0,1);
	}

	self.onEditPage = function() {
		//getPageListTree().startEditing(1,1);
		//update(1,0);
	}

	self.onAddPage = function() {
		self.selectedPageIndex= self.getPageListTreeIndex();
		self.pageList.splice(++self.selectedPageIndex, 0, "New-Page"); //@@@ TODO localise this
		self.update(1,0);
	}

	self.onRemovePage = function() {
		if (self.getPageListTreeIndex()==-1) return;
		self.pageList.splice(self.getPageListTreeIndex(), 1);
		self.selectedPageIndex--;
		self.update(1,0);
	}

	self.onGoRU = function() {
		var newTab= Application.activeWindow.open(self.url("http://www.RobinUpton.com?WP="+self.WPManager.extensionVersion));
		newTab.focus();
	}

	self.onGoWP = function() {
		var newTab= Application.activeWindow.open(self.url("http://www.WikipediaPlus.org?version="+self.WPManager.extensionVersion));
		newTab.focus();
	}

	self.onOptionsSave = function() {
		self.WPManager.setSiteList(self.siteList);
		self.WPManager.setPageList(self.pageList);
		self.WPManager.maxConnections= 			self.getMaxConnInput().value;
		self.WPManager.maxSuggestions= 			self.getMaxSuggInput().value;
		self.WPManager.notificationFormat=		self.getNotificationFormat().selectedIndex;
		//self.WPManager.notificationHeight=	self.getNotificationHeight().selectedIndex; No GUI
		self.WPManager.optionsTopTab= 			self.getOptionsTabbox().selectedIndex;
		self.WPManager.enabled=		 			self.getEnabled().checked;
		self.WPManager.sameLanguage=			self.getSameLanguage().checked;
		self.WPManager.searchWhile= 			self.getSearchWhile().checked;
		self.WPManager.showBubbles= 			self.getShowBubbles().checked;
		self.WPManager.showCancel= 				self.getShowCancelMenu().selectedIndex;
		self.WPManager.showIcon= 				self.getShowIcon().checked;
		self.WPManager.statusbarFormat=			self.getStatusbarFormat().selectedIndex;
		self.WPManager.showPreferredOnly= 		self.getShowPreferredOnly().checked;
		self.WPManager.suggestionFormat=		self.getSuggestionFormat().selectedIndex;
		self.WPManager.suggestionLocation=		self.getSuggestionLocation().selectedIndex;
		self.WPManager.update();
		return true;
	}

	self.onDemoteSite = function() {
		if (self.getSiteDemoteButton().disabled) return; //:)
		self.moveSiteListItem(self.getCurrentSite(), self.getSiteListTreeIndex()+2);
		self.selectedSiteIndex++;
		self.update(0,1);
	}

	self.onPromoteSite = function() {
		if (self.getSitePromoteButton().disabled) return; //:)
		self.moveSiteListItem(self.getCurrentSite(), self.getSiteListTreeIndex()-1);
		self.selectedSiteIndex--;
		self.update(0,1);
	}

	self.onRemoveSite = function() {
		var temp=self.getCurrentSite();
		if (typeof(temp)=="undefined") self.selectedSiteIndex=-1;
		else temp.parentNode.removeChild(temp);
		self.WPManager.changeSiteList();
		self.update(0,1);
	}

	self.onSiteListTreeClick = function(event) {
		if (event.detail > 1) self.onEditSite(); //Dbl+ click
	}

	self.onPageListTreeSelect = function() {
		self.selectedPageIndex= self.getPageListTreeIndex();
		self.updateButtonsAndSelection(1, 0);
	}

	self.onPageListTreeKeyPress = function(event) {
		if (event.keyCode == 46) self.onRemovePage(); // DEL key
	}

	self.onSiteListTreeSelect = function() {
		self.selectedSiteIndex= self.getSiteListTreeIndex();
		self.updateButtonsAndSelection(0, 1);
	}

	self.moveSiteListItem = function(fromItem, toIndex)
	{
		var toItem =self.getSiteListItem(toIndex);
		if (typeof(toItem)=='undefined') self.siteList.documentElement.appendChild(fromItem);
		else self.siteList.documentElement.insertBefore(fromItem, toItem);
	}

	self.update = function(pages, sites) {
		if (pages) self.setUpPagesTree();
		if (sites) self.setUpSitesTree();
		self.updateButtonsAndSelection(pages, sites);
	}

	self.updateButton = function(XULelement, status) {
		XULelement.disabled= (!status);
		XULelement.image=  "chrome://wikipediaPlus/content/images/"+XULelement.id.substring(4)+status+".png";
	}

	self.updateButtonsAndSelection = function(page, site) {
		if (site)
			{
			self.updateButton(self.getSiteEditButton(),		0+(self.selectedSiteIndex>=0));
			self.updateButton(self.getSiteRemoveButton(),	0+(self.selectedSiteIndex>=0));
			self.updateButton(self.getSitePromoteButton(),	0+(self.selectedSiteIndex>0));
			self.updateButton(self.getSiteDemoteButton(),	0+(self.selectedSiteIndex>-1 && self.selectedSiteIndex+1<self.getSiteListTreeLength()));
			self.getSiteListTree().view.selection.select(self.selectedSiteIndex);
			}
		if (page)
			{
			self.updateButton(self.getPageRemoveButton(),	0+(self.selectedPageIndex>=0));
			self.getPageListTree().view.selection.select(self.selectedPageIndex);
			}
	}

	self.url = function(path) {
		var ioSvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		return ioSvc.newURI(path, null, null);
	}

	self.setUpSitesTree = function() {
		var temp=self.getSitesTreeParent();
		removeChildNodes(temp);
		appendFragment(temp, transformToFragment(self.siteList, self.WPManager.getStylesheet(0)));
		self.setSiteListTreeIndex(self.selectedSiteIndex);
		var temptreecells=self.getSiteListTree().ownerDocument.evaluate(".//xul:treecell[@iconURL]", self.getSiteListTree(), function() { return "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"; }, XPathResult.ANY_TYPE, null);
		var treecells= new Array(); 
		while (temp = temptreecells.iterateNext()) treecells.push(temp);
		for (var i=0; i<treecells.length; i++) // Refer to the cache
			treecells[i].setAttribute('src', treecells[i].getAttribute('iconURL'));
		return; //@@@
	}

	self.setUpPagesTree = function() {
		var pagesTree= self.getPageListTree();
		pagesTree.view = {  
			rowCount : self.pageList.length,
			getCellText :		function(row, col) { return self.pageList[row]; },
			getCellValue:		function(row, col) { return 3; },
			setCellText:		function(row, col, val) { 
				if (val=="") self.onRemovePage();
				else self.pageList[row]=val;
				//self.setUpPagesTree(); 
				} ,
			getParentIndex:		function()			{} , 
			setTree: 			function(treebox)	{ this.treebox = treebox; },
			isContainer: 		function(row)		{ return false; },  
			isSeparator: 		function(row)		{ return false; },  
			isSorted: 			function()			{ return false; },  
			isEditable: 		function(row, col)	{ return true; },
			getLevel: 			function(row)		{ return 0; },  
			getImageSrc: 		function(row, col)	{ },  
			getRowProperties: 	function(row,props){},  
			getCellProperties:	function(row,col,props){},  
			getColumnProperties: function(colid,col,props){}  
		  };    
	}
};

// Init addin after window loaded
window.addEventListener("load", com.RobinUpton.WikipediaPlus.Options.init, false);
