<?xml version="1.0" encoding="UTF-8"?>
<!-- Last modified: 2012-04-29
Gets round a bug in Firefox v.11,12,
caused by the XML parser trying to validate the XUL when it isn't XUL.

This removes XUL elements from XSL stylesheets without changing the function.
Should be applied to the master XSL sheets to create the FF ready sheets.
GGRRRRRR! 2012-04-29 
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" >
	<!-- Any XUL elements might annoy the XML validator?? -->	
	<xsl:template match="/">
		<xsl:comment>*************************************************
* THIS SHEET IS AUTO-GENERATED TO AVOID A FIREFOX v11 ISSUE. 
* DO NOT HAND EDIT. INSTEAD EDIT THE MUCH MORE USER FRIENDLY
* '.src' SOURCE FILE AND RE-GENERATE IT
*************************************************"</xsl:comment>
		<xsl:apply-templates/>	
	</xsl:template>
	<xsl:template match="xul:*">
		<xsl:element name="xsl:element" namespace="http://www.w3.org/1999/XSL/Transform">
			<xsl:attribute name="name">
				<xsl:value-of select="local-name()"/>
			</xsl:attribute>
			<xsl:for-each select="@*">
				<xsl:element name="xsl:attribute" namespace="http://www.w3.org/1999/XSL/Transform">
					<xsl:attribute name="name">
						<xsl:value-of select="local-name()"/>
					</xsl:attribute>
					<xsl:choose>
						<!-- This bit is a bit of a kludge, since doesn't handle general {} expressions, but works for now! -->
						<xsl:when test="substring(.,1,1)='{'">
							<!-- {}, needs interpreting -->
							<xsl:element name="xsl:value-of" namespace="http://www.w3.org/1999/XSL/Transform">
								<xsl:attribute name="select">
									<xsl:value-of select="substring(.,2,string-length(.)-2)"/>
								</xsl:attribute>
							</xsl:element>
						</xsl:when>
						<xsl:otherwise>
							<!-- Literal Copy -->
							<xsl:value-of select="."/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:element>
			</xsl:for-each>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="node()">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>	
	</xsl:template>
</xsl:stylesheet>
